// This file was AUTOGENERATED; do not edit!

#[allow(unused_imports)]
use super::super::assert_eq;
use TestPPU;

#[inline(never)]
pub fn test_vram_access_during_background_rendering( ppu: &mut TestPPU ) {
    assert_eq!( ppu.scanline(), 261 );
    assert_eq!( ppu.dot(), 0 );
    for i in 0..4096u32 {
        ppu.write_vram( i as u16, (i + 0x80) as u8 );
    }
    for i in 0..960u32 {
        ppu.write_vram( (0x2000 + i) as u16, (i + 0x80) as u8 );
    }
    for i in 0..64u32 {
        ppu.write_vram( (0x2000 + 960 + i) as u16, (0x80 | i) as u8 );
    }
    ppu.write_ioreg( 1, 0x0A );
    ppu.step_pixel(); // 261 000 -> 261 001
    ppu.step_pixel(); // 261 001 -> 261 002
    ppu.step_pixel(); // 261 002 -> 261 003
    ppu.step_scanline();
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 000 -> 000 001
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 001 -> 000 002
    ppu.expect_vram_read( 0x2002, 0x82 );
    ppu.step_pixel(); // 000 002 -> 000 003
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 003 -> 000 004
    ppu.expect_vram_read( 0x23C0, 0x80 );
    ppu.step_pixel(); // 000 004 -> 000 005
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 005 -> 000 006
    ppu.expect_vram_read( 0x0820, 0xA0 );
    ppu.step_pixel(); // 000 006 -> 000 007
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 007 -> 000 008
    ppu.expect_vram_read( 0x0828, 0xA8 );
    ppu.step_pixel(); // 000 008 -> 000 009
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 009 -> 000 010
    ppu.expect_vram_read( 0x2003, 0x83 );
    ppu.step_pixel(); // 000 010 -> 000 011
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 011 -> 000 012
    ppu.expect_vram_read( 0x23C0, 0x80 );
    ppu.step_pixel(); // 000 012 -> 000 013
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 013 -> 000 014
    ppu.expect_vram_read( 0x0830, 0xB0 );
    ppu.step_pixel(); // 000 014 -> 000 015
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 015 -> 000 016
    ppu.expect_vram_read( 0x0838, 0xB8 );
    ppu.step_pixel(); // 000 016 -> 000 017
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 017 -> 000 018
    ppu.expect_vram_read( 0x2004, 0x84 );
    ppu.step_pixel(); // 000 018 -> 000 019
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 019 -> 000 020
    ppu.expect_vram_read( 0x23C1, 0x81 );
    ppu.step_pixel(); // 000 020 -> 000 021
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 021 -> 000 022
    ppu.expect_vram_read( 0x0840, 0xC0 );
    ppu.step_pixel(); // 000 022 -> 000 023
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 023 -> 000 024
    ppu.expect_vram_read( 0x0848, 0xC8 );
    ppu.step_pixel(); // 000 024 -> 000 025
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 025 -> 000 026
    ppu.expect_vram_read( 0x2005, 0x85 );
    ppu.step_pixel(); // 000 026 -> 000 027
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 027 -> 000 028
    ppu.expect_vram_read( 0x23C1, 0x81 );
    ppu.step_pixel(); // 000 028 -> 000 029
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 029 -> 000 030
    ppu.expect_vram_read( 0x0850, 0xD0 );
    ppu.step_pixel(); // 000 030 -> 000 031
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 031 -> 000 032
    ppu.expect_vram_read( 0x0858, 0xD8 );
    ppu.step_pixel(); // 000 032 -> 000 033
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 033 -> 000 034
    ppu.expect_vram_read( 0x2006, 0x86 );
    ppu.step_pixel(); // 000 034 -> 000 035
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 035 -> 000 036
    ppu.expect_vram_read( 0x23C1, 0x81 );
    ppu.step_pixel(); // 000 036 -> 000 037
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 037 -> 000 038
    ppu.expect_vram_read( 0x0860, 0xE0 );
    ppu.step_pixel(); // 000 038 -> 000 039
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 039 -> 000 040
    ppu.expect_vram_read( 0x0868, 0xE8 );
    ppu.step_pixel(); // 000 040 -> 000 041
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 041 -> 000 042
    ppu.expect_vram_read( 0x2007, 0x87 );
    ppu.step_pixel(); // 000 042 -> 000 043
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 043 -> 000 044
    ppu.expect_vram_read( 0x23C1, 0x81 );
    ppu.step_pixel(); // 000 044 -> 000 045
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 045 -> 000 046
    ppu.expect_vram_read( 0x0870, 0xF0 );
    ppu.step_pixel(); // 000 046 -> 000 047
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 047 -> 000 048
    ppu.expect_vram_read( 0x0878, 0xF8 );
    ppu.step_pixel(); // 000 048 -> 000 049
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 049 -> 000 050
    ppu.expect_vram_read( 0x2008, 0x88 );
    ppu.step_pixel(); // 000 050 -> 000 051
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 051 -> 000 052
    ppu.expect_vram_read( 0x23C2, 0x82 );
    ppu.step_pixel(); // 000 052 -> 000 053
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 053 -> 000 054
    ppu.expect_vram_read( 0x0880, 0x00 );
    ppu.step_pixel(); // 000 054 -> 000 055
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 055 -> 000 056
    ppu.expect_vram_read( 0x0888, 0x08 );
    ppu.step_pixel(); // 000 056 -> 000 057
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 057 -> 000 058
    ppu.expect_vram_read( 0x2009, 0x89 );
    ppu.step_pixel(); // 000 058 -> 000 059
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 059 -> 000 060
    ppu.expect_vram_read( 0x23C2, 0x82 );
    ppu.step_pixel(); // 000 060 -> 000 061
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 061 -> 000 062
    ppu.expect_vram_read( 0x0890, 0x10 );
    ppu.step_pixel(); // 000 062 -> 000 063
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 063 -> 000 064
    ppu.expect_vram_read( 0x0898, 0x18 );
    ppu.step_pixel(); // 000 064 -> 000 065
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 065 -> 000 066
    ppu.expect_vram_read( 0x200A, 0x8A );
    ppu.step_pixel(); // 000 066 -> 000 067
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 067 -> 000 068
    ppu.expect_vram_read( 0x23C2, 0x82 );
    ppu.step_pixel(); // 000 068 -> 000 069
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 069 -> 000 070
    ppu.expect_vram_read( 0x08A0, 0x20 );
    ppu.step_pixel(); // 000 070 -> 000 071
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 071 -> 000 072
    ppu.expect_vram_read( 0x08A8, 0x28 );
    ppu.step_pixel(); // 000 072 -> 000 073
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 073 -> 000 074
    ppu.expect_vram_read( 0x200B, 0x8B );
    ppu.step_pixel(); // 000 074 -> 000 075
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 075 -> 000 076
    ppu.expect_vram_read( 0x23C2, 0x82 );
    ppu.step_pixel(); // 000 076 -> 000 077
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 077 -> 000 078
    ppu.expect_vram_read( 0x08B0, 0x30 );
    ppu.step_pixel(); // 000 078 -> 000 079
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 079 -> 000 080
    ppu.expect_vram_read( 0x08B8, 0x38 );
    ppu.step_pixel(); // 000 080 -> 000 081
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 081 -> 000 082
    ppu.expect_vram_read( 0x200C, 0x8C );
    ppu.step_pixel(); // 000 082 -> 000 083
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 083 -> 000 084
    ppu.expect_vram_read( 0x23C3, 0x83 );
    ppu.step_pixel(); // 000 084 -> 000 085
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 085 -> 000 086
    ppu.expect_vram_read( 0x08C0, 0x40 );
    ppu.step_pixel(); // 000 086 -> 000 087
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 087 -> 000 088
    ppu.expect_vram_read( 0x08C8, 0x48 );
    ppu.step_pixel(); // 000 088 -> 000 089
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 089 -> 000 090
    ppu.expect_vram_read( 0x200D, 0x8D );
    ppu.step_pixel(); // 000 090 -> 000 091
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 091 -> 000 092
    ppu.expect_vram_read( 0x23C3, 0x83 );
    ppu.step_pixel(); // 000 092 -> 000 093
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 093 -> 000 094
    ppu.expect_vram_read( 0x08D0, 0x50 );
    ppu.step_pixel(); // 000 094 -> 000 095
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 095 -> 000 096
    ppu.expect_vram_read( 0x08D8, 0x58 );
    ppu.step_pixel(); // 000 096 -> 000 097
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 097 -> 000 098
    ppu.expect_vram_read( 0x200E, 0x8E );
    ppu.step_pixel(); // 000 098 -> 000 099
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 099 -> 000 100
    ppu.expect_vram_read( 0x23C3, 0x83 );
    ppu.step_pixel(); // 000 100 -> 000 101
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 101 -> 000 102
    ppu.expect_vram_read( 0x08E0, 0x60 );
    ppu.step_pixel(); // 000 102 -> 000 103
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 103 -> 000 104
    ppu.expect_vram_read( 0x08E8, 0x68 );
    ppu.step_pixel(); // 000 104 -> 000 105
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 105 -> 000 106
    ppu.expect_vram_read( 0x200F, 0x8F );
    ppu.step_pixel(); // 000 106 -> 000 107
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 107 -> 000 108
    ppu.expect_vram_read( 0x23C3, 0x83 );
    ppu.step_pixel(); // 000 108 -> 000 109
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 109 -> 000 110
    ppu.expect_vram_read( 0x08F0, 0x70 );
    ppu.step_pixel(); // 000 110 -> 000 111
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 111 -> 000 112
    ppu.expect_vram_read( 0x08F8, 0x78 );
    ppu.step_pixel(); // 000 112 -> 000 113
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 113 -> 000 114
    ppu.expect_vram_read( 0x2010, 0x90 );
    ppu.step_pixel(); // 000 114 -> 000 115
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 115 -> 000 116
    ppu.expect_vram_read( 0x23C4, 0x84 );
    ppu.step_pixel(); // 000 116 -> 000 117
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 117 -> 000 118
    ppu.expect_vram_read( 0x0900, 0x80 );
    ppu.step_pixel(); // 000 118 -> 000 119
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 119 -> 000 120
    ppu.expect_vram_read( 0x0908, 0x88 );
    ppu.step_pixel(); // 000 120 -> 000 121
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 121 -> 000 122
    ppu.expect_vram_read( 0x2011, 0x91 );
    ppu.step_pixel(); // 000 122 -> 000 123
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 123 -> 000 124
    ppu.expect_vram_read( 0x23C4, 0x84 );
    ppu.step_pixel(); // 000 124 -> 000 125
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 125 -> 000 126
    ppu.expect_vram_read( 0x0910, 0x90 );
    ppu.step_pixel(); // 000 126 -> 000 127
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 127 -> 000 128
    ppu.expect_vram_read( 0x0918, 0x98 );
    ppu.step_pixel(); // 000 128 -> 000 129
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 129 -> 000 130
    ppu.expect_vram_read( 0x2012, 0x92 );
    ppu.step_pixel(); // 000 130 -> 000 131
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 131 -> 000 132
    ppu.expect_vram_read( 0x23C4, 0x84 );
    ppu.step_pixel(); // 000 132 -> 000 133
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 133 -> 000 134
    ppu.expect_vram_read( 0x0920, 0xA0 );
    ppu.step_pixel(); // 000 134 -> 000 135
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 135 -> 000 136
    ppu.expect_vram_read( 0x0928, 0xA8 );
    ppu.step_pixel(); // 000 136 -> 000 137
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 137 -> 000 138
    ppu.expect_vram_read( 0x2013, 0x93 );
    ppu.step_pixel(); // 000 138 -> 000 139
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 139 -> 000 140
    ppu.expect_vram_read( 0x23C4, 0x84 );
    ppu.step_pixel(); // 000 140 -> 000 141
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 141 -> 000 142
    ppu.expect_vram_read( 0x0930, 0xB0 );
    ppu.step_pixel(); // 000 142 -> 000 143
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 143 -> 000 144
    ppu.expect_vram_read( 0x0938, 0xB8 );
    ppu.step_pixel(); // 000 144 -> 000 145
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 145 -> 000 146
    ppu.expect_vram_read( 0x2014, 0x94 );
    ppu.step_pixel(); // 000 146 -> 000 147
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 147 -> 000 148
    ppu.expect_vram_read( 0x23C5, 0x85 );
    ppu.step_pixel(); // 000 148 -> 000 149
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 149 -> 000 150
    ppu.expect_vram_read( 0x0940, 0xC0 );
    ppu.step_pixel(); // 000 150 -> 000 151
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 151 -> 000 152
    ppu.expect_vram_read( 0x0948, 0xC8 );
    ppu.step_pixel(); // 000 152 -> 000 153
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 153 -> 000 154
    ppu.expect_vram_read( 0x2015, 0x95 );
    ppu.step_pixel(); // 000 154 -> 000 155
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 155 -> 000 156
    ppu.expect_vram_read( 0x23C5, 0x85 );
    ppu.step_pixel(); // 000 156 -> 000 157
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 157 -> 000 158
    ppu.expect_vram_read( 0x0950, 0xD0 );
    ppu.step_pixel(); // 000 158 -> 000 159
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 159 -> 000 160
    ppu.expect_vram_read( 0x0958, 0xD8 );
    ppu.step_pixel(); // 000 160 -> 000 161
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 161 -> 000 162
    ppu.expect_vram_read( 0x2016, 0x96 );
    ppu.step_pixel(); // 000 162 -> 000 163
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 163 -> 000 164
    ppu.expect_vram_read( 0x23C5, 0x85 );
    ppu.step_pixel(); // 000 164 -> 000 165
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 165 -> 000 166
    ppu.expect_vram_read( 0x0960, 0xE0 );
    ppu.step_pixel(); // 000 166 -> 000 167
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 167 -> 000 168
    ppu.expect_vram_read( 0x0968, 0xE8 );
    ppu.step_pixel(); // 000 168 -> 000 169
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 169 -> 000 170
    ppu.expect_vram_read( 0x2017, 0x97 );
    ppu.step_pixel(); // 000 170 -> 000 171
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 171 -> 000 172
    ppu.expect_vram_read( 0x23C5, 0x85 );
    ppu.step_pixel(); // 000 172 -> 000 173
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 173 -> 000 174
    ppu.expect_vram_read( 0x0970, 0xF0 );
    ppu.step_pixel(); // 000 174 -> 000 175
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 175 -> 000 176
    ppu.expect_vram_read( 0x0978, 0xF8 );
    ppu.step_pixel(); // 000 176 -> 000 177
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 177 -> 000 178
    ppu.expect_vram_read( 0x2018, 0x98 );
    ppu.step_pixel(); // 000 178 -> 000 179
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 179 -> 000 180
    ppu.expect_vram_read( 0x23C6, 0x86 );
    ppu.step_pixel(); // 000 180 -> 000 181
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 181 -> 000 182
    ppu.expect_vram_read( 0x0980, 0x00 );
    ppu.step_pixel(); // 000 182 -> 000 183
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 183 -> 000 184
    ppu.expect_vram_read( 0x0988, 0x08 );
    ppu.step_pixel(); // 000 184 -> 000 185
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 185 -> 000 186
    ppu.expect_vram_read( 0x2019, 0x99 );
    ppu.step_pixel(); // 000 186 -> 000 187
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 187 -> 000 188
    ppu.expect_vram_read( 0x23C6, 0x86 );
    ppu.step_pixel(); // 000 188 -> 000 189
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 189 -> 000 190
    ppu.expect_vram_read( 0x0990, 0x10 );
    ppu.step_pixel(); // 000 190 -> 000 191
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 191 -> 000 192
    ppu.expect_vram_read( 0x0998, 0x18 );
    ppu.step_pixel(); // 000 192 -> 000 193
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 193 -> 000 194
    ppu.expect_vram_read( 0x201A, 0x9A );
    ppu.step_pixel(); // 000 194 -> 000 195
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 195 -> 000 196
    ppu.expect_vram_read( 0x23C6, 0x86 );
    ppu.step_pixel(); // 000 196 -> 000 197
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 197 -> 000 198
    ppu.expect_vram_read( 0x09A0, 0x20 );
    ppu.step_pixel(); // 000 198 -> 000 199
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 199 -> 000 200
    ppu.expect_vram_read( 0x09A8, 0x28 );
    ppu.step_pixel(); // 000 200 -> 000 201
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 201 -> 000 202
    ppu.expect_vram_read( 0x201B, 0x9B );
    ppu.step_pixel(); // 000 202 -> 000 203
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 203 -> 000 204
    ppu.expect_vram_read( 0x23C6, 0x86 );
    ppu.step_pixel(); // 000 204 -> 000 205
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 205 -> 000 206
    ppu.expect_vram_read( 0x09B0, 0x30 );
    ppu.step_pixel(); // 000 206 -> 000 207
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 207 -> 000 208
    ppu.expect_vram_read( 0x09B8, 0x38 );
    ppu.step_pixel(); // 000 208 -> 000 209
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 209 -> 000 210
    ppu.expect_vram_read( 0x201C, 0x9C );
    ppu.step_pixel(); // 000 210 -> 000 211
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 211 -> 000 212
    ppu.expect_vram_read( 0x23C7, 0x87 );
    ppu.step_pixel(); // 000 212 -> 000 213
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 213 -> 000 214
    ppu.expect_vram_read( 0x09C0, 0x40 );
    ppu.step_pixel(); // 000 214 -> 000 215
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 215 -> 000 216
    ppu.expect_vram_read( 0x09C8, 0x48 );
    ppu.step_pixel(); // 000 216 -> 000 217
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 217 -> 000 218
    ppu.expect_vram_read( 0x201D, 0x9D );
    ppu.step_pixel(); // 000 218 -> 000 219
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 219 -> 000 220
    ppu.expect_vram_read( 0x23C7, 0x87 );
    ppu.step_pixel(); // 000 220 -> 000 221
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 221 -> 000 222
    ppu.expect_vram_read( 0x09D0, 0x50 );
    ppu.step_pixel(); // 000 222 -> 000 223
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 223 -> 000 224
    ppu.expect_vram_read( 0x09D8, 0x58 );
    ppu.step_pixel(); // 000 224 -> 000 225
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 225 -> 000 226
    ppu.expect_vram_read( 0x201E, 0x9E );
    ppu.step_pixel(); // 000 226 -> 000 227
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 227 -> 000 228
    ppu.expect_vram_read( 0x23C7, 0x87 );
    ppu.step_pixel(); // 000 228 -> 000 229
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 229 -> 000 230
    ppu.expect_vram_read( 0x09E0, 0x60 );
    ppu.step_pixel(); // 000 230 -> 000 231
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 231 -> 000 232
    ppu.expect_vram_read( 0x09E8, 0x68 );
    ppu.step_pixel(); // 000 232 -> 000 233
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 233 -> 000 234
    ppu.expect_vram_read( 0x201F, 0x9F );
    ppu.step_pixel(); // 000 234 -> 000 235
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 235 -> 000 236
    ppu.expect_vram_read( 0x23C7, 0x87 );
    ppu.step_pixel(); // 000 236 -> 000 237
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 237 -> 000 238
    ppu.expect_vram_read( 0x09F0, 0x70 );
    ppu.step_pixel(); // 000 238 -> 000 239
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 239 -> 000 240
    ppu.expect_vram_read( 0x09F8, 0x78 );
    ppu.step_pixel(); // 000 240 -> 000 241
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 241 -> 000 242
    ppu.expect_vram_read( 0x2400, 0x80 );
    ppu.step_pixel(); // 000 242 -> 000 243
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 243 -> 000 244
    ppu.expect_vram_read( 0x27C0, 0x80 );
    ppu.step_pixel(); // 000 244 -> 000 245
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 245 -> 000 246
    ppu.expect_vram_read( 0x0800, 0x80 );
    ppu.step_pixel(); // 000 246 -> 000 247
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 247 -> 000 248
    ppu.expect_vram_read( 0x0808, 0x88 );
    ppu.step_pixel(); // 000 248 -> 000 249
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 249 -> 000 250
    ppu.expect_vram_read( 0x2401, 0x81 );
    ppu.step_pixel(); // 000 250 -> 000 251
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 251 -> 000 252
    ppu.expect_vram_read( 0x27C0, 0x80 );
    ppu.step_pixel(); // 000 252 -> 000 253
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 253 -> 000 254
    ppu.expect_vram_read( 0x0810, 0x90 );
    ppu.step_pixel(); // 000 254 -> 000 255
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 255 -> 000 256
    ppu.expect_vram_read( 0x0818, 0x98 );
    ppu.step_pixel(); // 000 256 -> 000 257
    for _ in 0..64u32 {
        ppu.step_pixel();
    } // 000 320 -> 000 321
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 321 -> 000 322
    ppu.expect_vram_read( 0x2000, 0x80 );
    ppu.step_pixel(); // 000 322 -> 000 323
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 323 -> 000 324
    ppu.expect_vram_read( 0x23C0, 0x80 );
    ppu.step_pixel(); // 000 324 -> 000 325
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 325 -> 000 326
    ppu.expect_vram_read( 0x0801, 0x81 );
    ppu.step_pixel(); // 000 326 -> 000 327
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 327 -> 000 328
    ppu.expect_vram_read( 0x0809, 0x89 );
    ppu.step_pixel(); // 000 328 -> 000 329
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 329 -> 000 330
    ppu.expect_vram_read( 0x2001, 0x81 );
    ppu.step_pixel(); // 000 330 -> 000 331
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 331 -> 000 332
    ppu.expect_vram_read( 0x23C0, 0x80 );
    ppu.step_pixel(); // 000 332 -> 000 333
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 333 -> 000 334
    ppu.expect_vram_read( 0x0811, 0x91 );
    ppu.step_pixel(); // 000 334 -> 000 335
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 335 -> 000 336
    ppu.expect_vram_read( 0x0819, 0x99 );
    ppu.step_pixel(); // 000 336 -> 000 337
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 337 -> 000 338
    ppu.expect_vram_read( 0x2002, 0x82 );
    ppu.step_pixel(); // 000 338 -> 000 339
    ppu.expect_no_vram_read();
    ppu.step_pixel(); // 000 339 -> 000 340
    ppu.expect_vram_read( 0x2002, 0x82 );
    ppu.step_pixel(); // 000 340 -> 001 000
    assert_eq!( ppu.scanline(), 1 );
    assert_eq!( ppu.dot(), 0 );
}
